it-roy-ru.com

Maven 3 предупреждения о build.plugins.plugin.version

Поскольку я обновился до Maven 3, я получаю следующие предупреждающие сообщения при каждой сборке:

Как я могу избавиться от этих предупреждений?

[INFO] Scanning for projects...
[WARNING] 
[WARNING] Some problems were encountered while building the effective model for proj:id:jar:3.1
[WARNING] 'build.plugins.plugin.version' for org.Apache.maven.plugins:maven-javadoc-plugin is missing. @ line 195, column 15
[WARNING] 'build.plugins.plugin.version' for org.Apache.maven.plugins:maven-compiler-plugin is missing. @ line 204, column 15
[WARNING] 'build.plugins.plugin.version' for org.Apache.maven.plugins:maven-surefire-plugin is missing. @ line 227, column 15
[WARNING] 'build.plugins.plugin.version' for org.Apache.maven.plugins:maven-jar-plugin is missing. @ line 215, column 15
[WARNING] 'reporting.plugins.plugin.version' for org.codehaus.mojo:jdepend-maven-plugin is missing. @ line 271, column 15
[WARNING] 
[WARNING] It is highly recommended to fix these problems because they threaten the stability of your build.
[WARNING] 
[WARNING] For this reason, future Maven versions might no longer support building such malformed projects.
282
Istao

Добавьте элемент <version> после <plugin><artifactId> в свой файл pom.xml. Найдите следующий текст:

<plugin>
  <artifactId>maven-compiler-plugin</artifactId>

Добавьте тег версии к нему:

<plugin>
  <artifactId>maven-compiler-plugin</artifactId>
  <version>2.3.2</version>

Предупреждение должно быть устранено.

В соответствии с этим:

'build.plugins.plugin.version' для org.Apache.maven.plugins: отсутствует maven-compiler-plugin

Многие люди упоминали почему проблема возникает, но не могут предложить решение. Все, что мне нужно было сделать, это зайти в мой POM-файл для моего проекта и добавить тег <version>, как показано выше.

Чтобы узнать номер версии, можно посмотреть в выводе Maven после его завершения. Если вам не хватает номеров версий, Maven отобразит версию по умолчанию:

[INFO] --- maven-compiler-plugin:2.3.2:compile (default-compile) @ entities ---

Возьмите этот номер версии (как в 2.3.2 выше) и добавьте его в свой POM, как показано.

353
Todd

Беги как:

 $ mvn help: description -DartifactId = maven-war-plugin -DgroupId = org.Apache.maven.plugins 

для плагина, у которого нет версии. Вы получаете вывод:

 Имя: Maven WAR Plugin 
 Описание: Создает файл архива веб-приложения (WAR) из проекта 
 вывод и его зависимости .
 Идентификатор группы: org.Apache.maven.plugins 
 Идентификатор артефакта: maven-war-plugin 
 Версия: 2.2 
 Префикс цели: war 

Используйте версию, показанную в выводе.

UPDATE Если вы хотите выбрать из списка версий, используйте http://search.maven.org/ или http://mvnrepository.com/ Обратите внимание, что ваш любимый Java IDE должно иметь диалоговое окно поиска пакетов Maven. Просто проверьте документы.

SUPER UPDATE Я также использую:

$ mvn dependency:tree
$ mvn dependency:list
$ mvn dependency:resolve
$ mvn dependency:resolve-plugins  # <-- THIS

Недавно я узнал, как получить последнюю [ версию для плагина (или библиотеки), чтобы больше не нуждался в поиске в Google или посещении Maven Central:

$ mvn versions:display-dependency-updates
$ mvn versions:display-plugin-updates     # <-- THIS
76
gavenkoa

Maven 3 более строг с POM-структурой. Например, вы должны установить версии плагинов.

В maven 3.1 эти предупреждения могут нарушить вашу сборку. Есть больше изменений между maven2 и maven3: https://cwiki.Apache.org/confluence/display/MAVEN/Maven+3.x+Compatibility+Notes

13
Christian Kuetbach

Я использую родительский pom для своих проектов и хотел указать версии в одном месте, поэтому я использовал свойства, чтобы указать версию:

родительский пом:

<project xmlns="http://maven.Apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.Apache.org/POM/4.0.0
         http://maven.Apache.org/xsd/maven-4.0.0.xsd">
    ....
    <properties>
        <maven-compiler-plugin-version>2.3.2</maven-compiler-plugin-version>
    </properties>
    ....
</project>

проект пом:

<project xmlns="http://maven.Apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.Apache.org/POM/4.0.0
         http://maven.Apache.org/xsd/maven-4.0.0.xsd">
    ....
    <build>
        <finalName>helloworld</finalName>
        <plugins>
            <plugin>
                <groupId>org.Apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>${maven-compiler-plugin-version}</version>
                <configuration>
                    <source>1.6</source>
                    <target>1.6</target>
                </configuration>
            </plugin>
        </plugins>
    </build>
</project>

Смотрите также: https://www.allthingsdigital.nl/2011/04/10/maven-3-and-the-versions-dilemma/

9
Patrick Koorevaar

получить последнюю версию информации от:

https://mvnrepository.com/artifact/org.Apache.maven.plugins/maven-compiler-plugin

нажмите на последнюю версию (или ту, которую вы хотели бы использовать), и вы увидите информацию о зависимости:

<!-- https://mvnrepository.com/artifact/org.Apache.maven.plugins/maven-compiler-plugin -->
<dependency>
    <groupId>org.Apache.maven.plugins</groupId>
    <artifactId>maven-compiler-plugin</artifactId>
    <version>3.6.1</version>
</dependency>

вы можете использовать тег версии и комментарий для вашего тега плагина.

<!-- https://mvnrepository.com/artifact/org.Apache.maven.plugins/maven-compiler-plugin -->
<plugin>
    <artifactId>maven-compiler-plugin</artifactId>
    <version>3.6.1</version>
    <configuration>
        <source />
        <target />
    </configuration>
</plugin>

если хотите, вы можете изменить свой pom, чтобы информация о версии была в теге свойств, как указано в другом ответе.

4
Wolfgang Fahl

Это отличный ответ здесь. И я хочу добавить «Зачем добавлять элемент в Maven3».
In Замечания по совместимости с Maven 3.x

Разрешение метаверсии плагина
Внутри Maven 2.x использовались специальные маркеры версий RELEASE и LATEST для поддержки автоматического разрешения версии плагина. Эти метаверсии были также распознаны в элементе для объявления. Для воспроизводимых сборок Maven 3.x больше не поддерживает использование этих метаверсий в POM. В результате пользователи должны будут заменить вхождения этих метаверсий конкретной версией.

И я также нахожу в Maven-компилятор-плагин - использование

Примечание: Maven 3.0 будет выдавать предупреждения, если вы не укажете версию плагина.

2
ohahohah

Найдите «maven-jar-plugin» в pom.xml И добавьте тег версии Maven version

0
Shukant